import time
import pygame
from settings import *


if DOCTRL:
	try:
		pygame.joystick.init()
		joystick = pygame.joystick.Joystick(0)
		joystick.init()
	except:
		print "Joystick Load Fail"
		DOAXIS = False
		DOHAT = False
		HOJOYBTN = False
else:
	DOAXIS = False
	DOHAT = False
	HOJOYBTN = False

class inputwrangler():
	def __init__(self,deadzone=0.3):

		self.integral = {'up':0.0,'down':0.0,'left':0.0,'right':0.0}

		self.start =  {'up':0.0,'down':0.0,'left':0.0,'right':0.0}

		self.limit = {'up':0.0,'down':0.0,'left':0.0,'right':0.0}

		self.up = [0.0, 0.0, 0.0]
		self.down = [0.0, 0.0, 0.0]
		self.left = [0.0, 0.0, 0.0]
		self.right = [0.0, 0.0, 0.0]

		self.ok = [False, False]
		self.oksent = False

		self.deadzone = deadzone

	def reset(self):
		self.integral = {'up':0.0,'down':0.0,'left':0.0,'right':0.0}
		self.start =  {'up':0.0,'down':0.0,'left':0.0,'right':0.0}
		self.limit = {'up':0.0,'down':0.0,'left':0.0,'right':0.0}
		self.up = [0.0, 0.0, 0.0]
		self.down = [0.0, 0.0, 0.0]
		self.left = [0.0, 0.0, 0.0]
		self.right = [0.0, 0.0, 0.0]
		self.ok = [False, False]
	
	def InputActive(self):
		if sum(self.up) > 0:
			return True
		else:
			self.limit['up'] = 0.0
			self.integral['up'] = 0.0
		if sum(self.down) > 0:
			return True
		else:
			self.limit['down'] = 0.0
			self.integral['down'] = 0.0
		if sum(self.left) > 0:
			return True
		else:
			self.limit['left'] = 0.0
			self.integral['left'] = 0.0
		if sum(self.right) > 0:
			return True
		else:
			self.limit['right'] = 0.0
			self.integral['right'] = 0.0
		if any(self.ok):
			return True
		else:
			self.oksent = False
			return False

	def integrate(self):
		self.integral['down'] += (time.time() -self.start['down'])*sum(self.down)
		self.start['down'] = time.time()
		self.integral['up'] += (time.time() -self.start['up'])*sum(self.up)
		self.start['up'] = time.time()
		self.integral['right'] += (time.time() -self.start['right'])*sum(self.right)
		self.start['right'] = time.time()
		self.integral['left'] += (time.time() -self.start['left'])*sum(self.left)
		self.start['left'] = time.time()

	def Up(self):
		if sum(self.up) > self.deadzone:
			if self.integral['up'] > self.limit['up']:
				if self.limit['up'] == 0.0:
					self.limit['up'] = LIMITSTART
				self.limit['up'] = max(self.limit['up'] * LIMITDECAY, MAXSPEED)
				self.integral['up'] = 0.0
				return True
		else:
			self.limit['up'] = 0.0
			self.integral['up'] = 0.0
			return False

	def Down(self):
		if sum(self.down) > self.deadzone:
			if self.integral['down'] > self.limit['down']:
				if self.limit['down'] == 0.0:
					self.limit['down'] = LIMITSTART
				self.limit['down'] = max(self.limit['down'] * LIMITDECAY, MAXSPEED)
				self.integral['down'] = 0.0
				return True
		else:
			self.limit['down'] = 0.0
			self.integral['down'] = 0.0
			return False
	def Left(self):
		if sum(self.left) > self.deadzone:
			if self.integral['left'] > self.limit['left']:
				#self.limit['left'] *= LIMITDECAY
				if self.limit['left'] == 0.0:
					self.limit['left'] = LIMITSTART
				self.limit['left'] = max(self.limit['left'] * LIMITDECAY, MAXSPEED)
				self.integral['left'] = 0.0
				return True
		else:
			self.limit['left'] = 0.0
			self.integral['left'] = 0.0
			return False

	def Right(self):
		if sum(self.right) > self.deadzone:
			if self.integral['right'] > self.limit['right']:
				if self.limit['right'] == 0.0:
					self.limit['right'] = LIMITSTART
				self.limit['right'] = max(self.limit['right'] * LIMITDECAY, MAXSPEED)
				self.integral['right'] = 0.0
				return True
		else:
			self.limit['right'] = 0.0
			self.integral['right'] = 0.0
			return False
	def Ok(self):
		if any(self.ok):
			if not self.oksent:
				self.oksent = True
				return True
		else:
			self.oksent = False
		return False

	def update(self,event):
		if DOJOYBTN:
			self.ok[1] = joystick.get_button(OKBUTTONID)
		if event == None:
			#Joystick axis check.  Analog values come in here
			if DOAXIS:
				lr0 = joystick.get_axis(LRAXIS)*LRORIENT

				if abs(lr0) > self.deadzone:
					if lr0 > 0:
						self.right[1] = lr0
						self.left[1] = 0.0
					else:
						self.left[1] = -1.0 * lr0
						self.right[1] = 0.0
				else:
					self.left[1] = 0.0
					self.right[1] = 0.0



				ud0 = joystick.get_axis(UDAXIS)*UDORIENT
				if abs(ud0) > self.deadzone:
					if ud0 > 0:
						self.up[1] = ud0
						self.down[1] = 0.0
					else:
						self.down[1] = -1.0 * ud0
						self.up[1] = 0.0
				else:
					self.up[1] = 0.0
					self.down[1] = 0.0

			#Hats, hats hats hats hats hats - Hats are all on or all off
			if DOHAT:
				lr1,ud1 = joystick.get_hat(0)
				if lr1 == -1:
					self.left[2] = 1.0
					self.right[2] = 0.0
				elif lr1 == 1:
					self.right[2] = 1.0
					self.left[2] = 0.0
				else:
					self.right[2] = 0.0
					self.left[2] = 0.0
				if ud1 == 1:
					self.up[2] = 1.0
					self.down[2] = 0.0
				elif ud1 == -1:
					self.down[2] = 1.0
					self.up[2] = 0.0
				else:
					self.down[2] = 0.0
					self.up[2] = 0.0

			self.integrate() #perform calculations here because this is the last step in input scanning
		else:

			#Keyboard Scanning -- If it's a keyboard assume all on (1) or all off (0)
			if event.type == pygame.KEYDOWN:
				if event.key == pygame.K_RIGHT:
					self.right[0] = 1.0
				elif event.key == pygame.K_LEFT:
					self.left[0] = 1.0
				elif event.key == pygame.K_UP:
					self.up[0] = 1.0
				elif event.key == pygame.K_DOWN:
					self.down[0] = 1.0
				elif event.key == pygame.K_RETURN:
					self.ok[0] = True
			if event.type == pygame.KEYUP:
				if event.key == pygame.K_RIGHT:
					self.right[0] = 0.0
				elif event.key == pygame.K_LEFT:
					self.left[0] = 0.0
				elif event.key == pygame.K_UP:
					self.up[0] = 0.0
				elif event.key == pygame.K_DOWN:
					self.down[0] = 0.0
				elif event.key == pygame.K_RETURN:
					self.ok[0] = False

