############################################
## MISC SETTINGS
############################################
SOUND = True # If true, a "boop" will sound when the selection changes
OKSOUND = "menu-validate.wav"
OKVOL = 1.0
NGSOUND = "menu-back.wav"
NGVOL = 1.0
SELECTSOUND = "menu-select.wav"
SELVOL = 1.0
EXITSOUND = "menu-validate.wav"
EXITVOL = 1.0
BKGSOUND = "spanishflea.ogg"
BKGVOL = 0.5
AUTOUPDATE = False # If true, menugen will be ran every time the interface is started

############################################
## DISPLAY SETTINGS
############################################
WIDTH=1000
HEIGHT=800
FULLSCREEN = False
TEXTSIZE = 60
TEXTPAD = 8
FONT = None
MAXFRAMERATE = 60
MENU_PAD = 15 # Number of items above and below the current selection to show

#Colors
BLACK = (0, 0, 0)
WHITE = (255, 255, 255)
RED = (255, 0, 0)
GREEN = (0, 255, 0)
BLUE = (0, 0, 255)
LRED = (100,0,0)
BGCOLOR = BLACK # The color for the background

# These specify the colors of the menus.
# The ACTIVE menu is the one you are currenlty on.
# Selected text is the active selection.
# Unselected text is all other text
TEXT_UNSELECTED_ACTIVE = WHITE
TEXT_UNSELECTED = WHITE
TEXT_SELECTED_ACTIVE = RED
TEXT_SELECTED = LRED

############################################
## INPUT SETTINGS
############################################
OKBUTTONID = 0   # ID of the o.k. button on the joypad
UDAXIS = 1       # ID of the up/down axis on the joypad
UDORIENT = -1.0  # Either 1.0 or -1.0 to orient the axis, + = up
LRAXIS = 0       # ID of the left/right axis on the joypad
LRORIENT = 1.0   # Either 1.0 or -1.0 to orient the axis, + = right
CONTROLLERID = 0 # ID# of the controller to use for control
DOCTRL = True   # Enable/disable using a controller
DOAXIS = True   # Enable/disable using joysticks; Only used if DOCTRL = True
DOHAT = False    # Enable/disableusing the d-pad; Only used if DOCTRL = True
DOJOYBTN = True # Enable/disable using buttons on joypad; Only used if DOCTRL = True

############################################
## SCROLL SPEED SETTINGS
############################################
MAXSPEED = 0.02   # Max speed in seconds before next option is chosen
LIMITSTART = 0.5 # How long to delay before automatically going to next item when direction held
LIMITDECAY = 0.8 # Ratio between each consecutive automatic movement while direction held
